#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#define F_CPU 5000000UL
#define RightSwitch PB5
#define RedLight PB3
#define LeftSwitch PB2
#define GreenLight PB0
#define MultiLight PB1
#define randomTime(max) randomResult=(rand()/(RAND_MAX/(max+1)+1))/1.0
#define FirstDigitZero() PORTC = 0b00000000; 
// DDR 1 enable 0 disable
// PB5 right switch
// PB3 Red 
// PB2 left-switch 
// PB1 Multi 
// PB0 Green 
// digit selection in PC
// 1: 00, 2: 10, 3: 01, 4:11
// define number in 7-segment 
// 0: 0000
// 1: 0100
// 2: 1000
// 3: 1100
// 4: 0010
// 5: 0110
// 6: 1010
// 7: 1110
// 8: 0001
// 9: 0101
// don't use bitshifting with 7-segment and led
// many time it seem they don't work correctly
// tip: for bitshifting, don't use or with and in the same line
static int state;
static float randomResult;
static float time;
static float responseTime;
char isButtonPress(char bit)
{
    DDRB &=~(1<<bit);
    return !((PINB & (1<<bit))>>bit);
}
void showTime()
{
    int timeDigitTwo=(int)time/100%10;
    int timeDigitThree=(int)time/10%10;
    int timeDigitFour=(int)time%100%10;
    
    FirstDigitZero();
    _delay_ms(2);
    switch(timeDigitThree)
    {
        case 0: PORTC = 0b00010000; break; 
        case 1: PORTC = 0b00010100; break; 
        case 2: PORTC = 0b00011000; break;
        case 3: PORTC = 0b00011100; break;
        case 4: PORTC = 0b00010010; break;
        case 5: PORTC = 0b00010110; break;
        case 6: PORTC = 0b00011010; break;
        case 7: PORTC = 0b00011110; break;
        case 8: PORTC = 0b00010001; break;
        case 9: PORTC = 0b00010101; break;
    }
    _delay_ms(3);
    switch(timeDigitTwo)
    {
        case 0: PORTC = 0b00100000; break;
        case 1: PORTC = 0b00100100; break;
        case 2: PORTC = 0b00101000; break;
        case 3: PORTC = 0b00101100; break;
        case 4: PORTC = 0b00100010; break;
        case 5: PORTC = 0b00100110; break;
        case 6: PORTC = 0b00101010; break;
        case 7: PORTC = 0b00101110; break;
        case 8: PORTC = 0b00100001; break;
        case 9: PORTC = 0b00100101; break;
    }
    _delay_ms(3);
    switch(timeDigitFour)
    {
        case 0: PORTC = 0b00110000; break;
        case 1: PORTC = 0b00110100; break;
        case 2: PORTC = 0b00111000; break;
        case 3: PORTC = 0b00111100; break;
        case 4: PORTC = 0b00110010; break;
        case 5: PORTC = 0b00110110; break;
        case 6: PORTC = 0b00111010; break;
        case 7: PORTC = 0b00111110; break;
        case 8: PORTC = 0b00110001; break;
        case 9: PORTC = 0b00110101; break;
    }
    _delay_ms(5);
}
main()
{ 
    state=0;
    DDRB  = 0b00111111;
    PORTB = 0b00100100;
    DDRC  = 0b00111111;

    while (1)
    {
        // for button
        if(isButtonPress(RightSwitch))
        {
            while(!isButtonPress(RightSwitch));
            if(state==0) 
            {
                while(!isButtonPress(RightSwitch));
                randomTime(920);
                state=1;
            }
            else if(state==2) 
            {
                while(!isButtonPress(RightSwitch));
                _delay_ms(3000);
                state=0;
            }
            else if(state==3) 
            {
                _delay_ms(10);
                while(!isButtonPress(RightSwitch));
                state=0;
                _delay_ms(3000);
            }
        }
        else if(isButtonPress(LeftSwitch))
            if(state==1)
                if(time<randomResult | time>randomResult+75) 
                    state=3;
                else state=2;

        // for led, 7-segment
        // for state detection, don't change if to else if
        if(state==0)
        {
            responseTime=0.00;
            time=0.00;
            PORTB = 0b00100100; // don't change here
            _delay_ms(8);
            showTime();
        }
        if(state==1)
        {
            time+=0.1;
            showTime();
            if(time>999.00) state=3;
            if(time>=randomResult) 
            {
                PORTB=0b00001100; // don't change here either
                responseTime+=0.1;
            }
            else PORTB|=(1<<GreenLight) |(1<<LeftSwitch); 
        }
        if(state==2)
        {
            time=responseTime;
            PORTB &= (0<<RedLight);
            PORTB |= (1<<GreenLight) | (1<<RightSwitch); 
            showTime();
            _delay_ms(1);
            FirstDigitZero();
            _delay_ms(1);
        }
        if(state==3)
        {
            if(responseTime>0.00 && time<998.00) 
                time=responseTime;
            showTime();
            _delay_ms(1);
            FirstDigitZero();
            _delay_ms(1);
            PORTB |= (1<<RightSwitch) | (1<<MultiLight) ;
            
        }
    }
    return 0;
}
